# Compucell3d 3.7.7
from PySteppables import *
import CompuCell
import sys
import math

# Note that since there are no constraints on the cell locations in a long simulation the 
# sphere of cells is likely to collapse. Use focal point plasticities to anchor cell to their 
# staring positons or to their nearest neightbors.

# some varriables that it'll be nice to have access in in all the stepables
radius   = 30.  # radius of sphere of cells
cellSize =  5.  # width of a cell

class ConstraintInitializerSteppable(SteppableBasePy):
    def __init__(self,_simulator,_frequency=1):
        SteppableBasePy.__init__(self,_simulator,_frequency)
    def start(self):
        # create a hollow sphere of 'size'^3 voxel cells with a radius of 'radius' pixels
        # visit evey 'size'th pixel in the lattice and if it is within the target sphere 
        # radius plus or minus a little slop, then create a cell there.      
        for x in range (0,self.dim.x,int(cellSize)):  # these are the x, y and z width of the simulation bounding box
            for y in range (0,self.dim.y,int(cellSize)):
                for z in range (0,self.dim.z,int(cellSize)):
                    #print x,y,z
                    dist = math.sqrt((self.dim.x/2. - x)**2 + (self.dim.y/2. - y)**2 + (self.dim.z/2. - z)**2)
                    if abs(radius - dist) <= 2.:
                        print x,y,z
                        newcell=self.newCell(self.MYCELL)
                        self.cellField[x:int(x+cellSize-1),y:int(y+cellSize-1),z:int(z+cellSize-1)]=newcell # size of cell will be SIZExSIZExSIZE
                        # because of the shell thickness the cells are too big, 
                        # hence the divides in the lines below.
                        newcell.targetVolume  = 4./3.*3.14159*cellSize**3 / 2.
                        newcell.lambdaVolume  = 10.0
                        newcell.targetSurface = 4.*3.14159*cellSize**2 / 2.
                        newcell.lambdaCurface = 10.0        
        